$dbg=0;

=head1 NAME

Phrase.pl - full text searching perl script

=head1 SYNOPSIS

usage:

  perl Phrase.pl

Show brief usage
Please refer "brief usage" for options.

  
  perl Phrase.pl Search+Phrase-NotThis [Options]  >outfile.htm

Search for paragraphs that contain "Search" and/or "Phrase" but not "NotThis"

  
  perl phrase.pl "th(is|at)+th[eo]se" -e txt  >outfile.htm

Search all the .txt files for paragraphs that contain "this" and/or "that", 
"these", "those"

  
  perl phrase.pl "\bc\b-\bc\+\++pascal"

If you know perl, than you would know \b. This search means search for 
whole-word-only C and Pascal but does not want C++

=head1 Description

I keep two search tools for my daily use

  GREP form Borland
  TS from Norton Utility

I  use grep extensively. It does excellent job when I search for program
lines.	But it can not highlight the keywords found. And, it  lacks  the
context when I search for an idea or something.

So	I  turn  to TS from time to time. It overcomes the above two  grep's
drawbacks, but it introduces other nuisances: It requires too much	user
interaction. I have to press far too many 'Y's before I can skip a  file
I am not care. And I can't refer back what I've searched.

So, here is my solution to it -- My phrase search.pl, A perl script that grep 
on certain files in certain dir for certain phrases on paragraph based. FREE!

Phrase.pl: A full text searching perl script. B<Paragraph based> search for 
keyword phrases output (into html file) with found keyword emphasized. Support 
regular expressions and perl extended regular expressions. Smart algorithm 
that combine "and" ,"or" together. Sufficient and efficient. 

=head1 Algorithm

scan every file (include all that in the subdir)

search on *paragraph basis* instead of line basis on each file.

=cut

BEGIN {
use File::Basename;
#print "@INC\n";
push @INC, dirname($0);
#print "@INC\n";
}
		
# == Uses
use IO::File;
use Getopt::Std;
		
use Pattern;

if ( $dbg ) {
	use Data::Dumper;
	}

# == Constant setting


#
#
# == Script begins 
#
#

my %HoP = ();
%h_files;
my $h_files_ndx='00001';

my @paragraph=();
my $PhrSeperator='^(\s|\W|_)*\n';
my $FileValidPattern;

if ( $dbg >= 90 ){
	#ParasePattern("th(is|at)+th[eo]se",\%HoP);
	#ParasePattern('\bc\b-\bc\+\++pascal',\%HoP);
	#ParasePattern('\bc\b-c\+\++pascal',\%HoP);
	
	ParasePattern('sample+test-first',\%HoP);
	#warn ">>>>Dumper\n" . Dumper(%HoP) . "<<<<Dumper\n";
	print '<BODY BGCOLOR="#FFFFFF" TEXT="#000000">' . "\n";
	print "<PRE>Search files with pattern include:\n  ";
	# NOK print join(' ',$HoP{incl}); 
	print join(' ',@{$HoP{incl}}); 
	print "\n and pattern exclude:\n  ";
	print join(' ',@{$HoP{excl}}) . "\n";
	$opt_a=2;
	DealFileHandle("Test", DATA );
	exit(0);
	}

usage() if !@ARGV;

# Please note that shifting off the none-switch-character-proceeded arguments
# are crucial for getopt to work correctly.

ParasePattern( shift @ARGV, \%HoP);
print '<BODY BGCOLOR="#FFFFFF" TEXT="#000000">' . "\n";
print "\n<H2>Patterns:</H2>\n";
print "<PRE><I>Search files with pattern include:</I>\n  ";
print join(' ',@{$HoP{incl}}); 
print "\n <I>and pattern exclude:</I>\n  ";
print join(' ',@{$HoP{excl}}) . "\n";

# sets $opt_x (where x is the switch name) to the value of the argument, or 1 
# if no argument.
getopts('a:d:e:i:m:rt:');  

# -i -, Ignore case: off: case_on =1
$opt_i=$opt_i eq '-'? 1:0;

# -m -, Mark keyword found off: 
$opt_m=$opt_m eq '-'? 1:0;
@cback = ( \&cback_subs_on, \&cback_subs_off );

print "\n<H2>Options:</H2>\n <B>Case search:</B> ". ("Off","On")[$opt_i]. 
	"\n <B>Mark keyword</B>: ". ("On","Off")[$opt_m]. "\n\n";
	
print_ndx();
print "\n- - - - >8 - - - -\n";

if ( !$opt_a ) {$opt_a='+';}
if ( $opt_a eq '+' ) {$opt_a=@{$HoP{incl}};}

if ($opt_e) {
	@opt_e=split(/ /,$opt_e);
	$FileValidPattern = '.*?\.(' . join('|',@opt_e) . ').*';
	#warn $FileValidPattern;
	}

#warn "A: $opt_a, D: $opt_d, E: $opt_e, I: $opt_i, $opt_t, \n";

if ($opt_t) { $dbg = $opt_t; }

if (!$opt_d) {
	$opt_d='.';}
	
warn "Searching $opt_d\n";
dodir($opt_d);

print "\n\n<a name=\"ndx\"><H1>File Index</H1></a>\n";
foreach $key (sort(keys %h_files)) {
	print qq[\n<a href="#$key">$h_files{$key}</a>];
	}
													

sub print_ndx {
	print "<a href=\"#ndx\">File Index</a>\n";
	}
	
sub dodir {
	local($dir) = @_;
	#warn "DoDir is called with '$dir'.\n";

=head2 Perl dodir Bug

How nice. I can embed what I've tried in code without disgrade anything.
The following results come from my interactive perl learning script
http://www.geocities.com/SiliconValley/Lakes/2659/lp.htm

	# Bug ? opendir can't work when specified with any '/' or '\'
	# can only work with . or .. and even : ...

 ([undefined]) ? opendir(DIR,"e:/.")
 (1) ? closedir(DIR)
 (1) ? opendir(DIR,'e:/.')
 (1) ? opendir(DIR,'e:/')
 ([undefined]) ? opendir(DIR,'e:\')
 Can't find string terminator "'" anywhere before EOF
 ([undefined]) ? opendir(DIR,'e:\\')
 ([undefined]) ? exit

=cut

	opendir(DIR,$dir) || die "Can't open $dir";
	local(@filenames) = readdir(DIR);
	closedir(DIR);

	for (@filenames) {
		next if $_ eq '.';
		next if $_ eq '..';
		$name = "$dir/$_";
		DealFile ( $name ) if IsValid ( $name );

		next unless -d $name;

		# It really is a directory, so do it recursively.
		&dodir($name)
			if $opt_r ;
		}
	}

sub IsValid {
	if ( !$opt_e ){
		return 1;}

	return (shift @_) =~ /$FileValidPattern/i;
	}

sub DealFile {
	my $fn = shift (@_); 

	my $fh = new IO::File "<$fn" ||
		die "Can't scan $fn: $!";
	
	DealFileHandle ( $fn, $fh );
	}

	
sub DealFileHandle {
	my $fn = shift; 
	my $fh = shift; 
	my $first = 1;
	my $found;
	my $ii;

	print STDERR "\n$fn\n"; # Visual clue: one file
	
	# loop of all paragraphs in a file.
	PARA: while ( !eof($fh) ){
		
		# Loop of getting lines to form one paragraph.
		@paragraph=();
		LINE: while(<$fh>){

			# Strange ! 
			# Program got hold on the following line for 
			# input lines with many blanks ahead. (Wed	08-13-97 )
			# It will wait for a long long time then go on very fast.
			#print /^( |\t|\W)*\n$/o;
			#last LINE if /$PhrSeperator/o ;
			# The same thing happens to Win NT!
			# Workaround it:
			
			$line = $_;
			$line =~ tr [\n\t\x20-\x40\x5b-\x60\x7b-\x7e]/ /s;
			#warn "_<$line>_\n" if $dbg== 97 && length($line)<3;
			#warn "-Empty!\n" if $dbg== 97 && $line eq " ";
			
			last LINE if $line eq ' ';
			
			$paragraph[$#paragraph+1]=$_;
			}
		
		next PARA unless @paragraph;   # empty paragraph!
		
		# Got a paragraph.
		# Test if found in the paragraph.
		# if Exclude string found, get the next paragraph
		
		#warn "\n\n- v - v - v -\n";
		#warn join("_-|",@paragraph);
		print STDERR ".";   # Visual clue: one paragraph, standard
		
		$found = PatternPEI(\%HoP,\@paragraph,$cback[$opt_m],$opt_i);
		
		
		#warn "$found,  $opt_a, ${$found < $opt_a}. \n";

		next PARA if $found < $opt_a;	# get the next paragraph
										# if not found or too less
										
		# output the file name if be the first time
		if ( $first ) {
			$first = 0;
			print qq{\n<a name="$h_files_ndx"></a>\n};
			print_ndx();
			print qq{<H1>==== $fn ====</H1>\n};
			$h_files{$h_files_ndx}=$fn;
			$h_files_ndx++;
			}
		
		# output the paragraph 
		print "\n>>>>\n";
		print join("",@paragraph);
		print "<<<<\n";
		
		}
	}
	
sub cback_subs_on {
	my $line_ref= shift;
	my $patt	= shift;
	
	#warn $$line_ref;
	$$line_ref	 =~ s|($patt)|<B>$1</B>|ig;
	#warn $$line_ref;
	}

sub cback_subs_off {
	}

sub usage {
	die <<USAGE_HELP;

Usage:
  perl Phrase.pl Search+Phrase-NotThis [Options]  >outfile.htm
  perl phrase.pl "th(is|at)+th[eo]se" -e txt  >outfile.htm
  
Description: 
 A full text searching perl script. "Paragraph based" search for keyword 
 phrases output (into html file) with found keyword emphasized. Support 
 regular expressions and perl extended regular expressions. Smart algorithm 
 that combine "and" ,"or" together. Sufficient and efficient. 

Options are:
  -d Dir .................... C:. (default: current dir)
  -e "file Extension list" .. "txt faq c"
  -i -|+ .................... Ignore case: off / on(default) 
  -r	 .................... Recursive : on / off(default)  
  -m -|+ .................... Mark keyword found: off / on(default) 
  -a #|+ .................... at least # / all(default) the include phrases
  ....................  should be present in the paragraph)

Freely use & distribute. All rights reserved. SUN, Tong <suntong\@goecities.com>
USAGE_HELP
;
	}


=head1 Sample

Uhmm, I wonder how to use the newly introduced function chomp. No problem, use 
my Phrase.pl to search for sample usages. Let's search the current directory 
for .pl programs.

	perl phrase.pl chomp -e pl >chomp.htm

Here comes the result. It is really quick!
http://www.geocities.com/SiliconValley/Lakes/2659/chomp.htm

=head1 AUTHOR

Sun Tong E<lt>F<suntong@goecities.com>E<gt>

=head1 COPYRIGHT

Copyright (c) 1997 Sun Tong. All rights reserved.

This program is I<FREEWARE>, but B<requires you to register> -- just send me an 
email :-). I want to know where my program goes.

=head1 REGISTER & OTHER INFOMATION

Register syntax:

 To:	  suntong@geocities.com
 Subject: Register Phrase <Your Country> <Your state>
 Body:	  <Maybe blank, Any comments, bug reports, etc, are
	  welcome>

Comments:

=over 4

=item *

You should substitute the information in the < >. 

=item *

Your country: Please use your internet country code. For example, China is 
CN, America is US.

=item *

Your state: Please choose a common used name or initial. 

=back

You are welcome to my home page
http://www.geocities.com/SiliconValley/Lakes/2659/
. You'll find more FREE tools there.

This page is automatically generated by pod2html from perl -- 
http://www.perl.com

=head1 TODO

=cut


__END__



There is a site at:   http://www.lyrics.ch/
which has the words to songs and some links to other sites that do also.

										Deirdre

 ------------------------------


>This is the first sample paragraph
>text for the test.
>
>	 
#
#This is the second sample paragraph
#text for the test.
#		 
#	 
#THIS SAMPLE IS THE SAMPLE PARAGRAPH
TEXT FOR THE SAMPLE TEST.
___________________
-------------------
+++++++++++++++++++
===================
///////////////////
\\\\\\\\\\\\\\\\\\\
A paragraph
that contains nothing.
|||||||||||||||||||
###################
~!@#$%^&*()_+|\=-`<>?,./
A paragraph
that contains part text for the test.

#THIS SAMPLE IS THE SAMPLE PARAGRAPH
TEXT FOR THE SAMPLE TEST.
